
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>4.2 PCIe体系结构的组成部件 / iVAN</title>

    <meta name="description" content="4.2 PCIe体系结构的组成部件 PCIe总线作为处理器系统的局部总线,其作用与PCI总线类似,主要目的是为了连接处理器系统中的外部设备,当然PCIe总线也可以连接其他处理器系统.在不同的处理器系统中,PCIe体系结构的实现方法略有不同.但是在大多数处理器系统中,都使用了RC.Switch和PCIe-to-PCI桥这些基本模块连接PCIe和PCI设备.在PCIe总线中,基于PCIe总线的设备,也被称为EP(Endpoint). 4.2.1 基于PCIe架构的处理器系统 在不同的处理器系统中,PCIe体系结构的实现方式不尽相同.P">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">4.2 PCIe体系结构的组成部件</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>PCIe总线作为处理器系统的局部总线，其作用与PCI总线类似，主要目的是为了连接处理器系统中的外部设备，当然PCIe总线也可以连接其他处理器系统。在不同的处理器系统中，PCIe体系结构的实现方法略有不同。但是在大多数处理器系统中，都使用了RC、Switch和PCIe-to-PCI桥这些基本模块连接PCIe和PCI设备。在PCIe总线中，基于PCIe总线的设备，也被称为EP(Endpoint)。</p>
<h3><a>4.2.1 基于PCIe</a>架构的处理器系统</h3>
<p>在不同的处理器系统中，PCIe体系结构的实现方式不尽相同。PCIe体系结构以Intel的x86处理器为蓝本实现，已被深深地烙下x86处理器的印记。在PCIe总线规范中，有许多内容是x86处理器独有的，也仅在x86处理器的Chipset中存在。在PCIe总线规范中，一些最新的功能也在Intel的Chipset中率先实现。本节将以一个虚拟的处理器系统A和PowerPC处理器为例简要介绍RC的实现，并简单归纳RC的通用实现机制。</p>
<h4>1 处理器系统A</h4>
<p>在有些处理器系统中，没有直接提供PCI总线，此时需要使用PCIe桥，将PCIe链路转换为PCI总线之后，才能连接PCI设备。在PCIe体系结构中，也存在PCI总线号的概念，其编号方式与PCI总线兼容。一个基于PCIe架构的处理器系统A如图4?7所示。</p>
<p> <a href="http://photo.blog.sina.com.cn/showpic.html#blogid=6472c4cc01018893&amp;url=http://s9.sinaimg.cn/orignal/6472c4ccga6f9a906f3f8" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnBoLjEyNi5uZXQvOFJYR2VwdVdiSEpCRDdXX3YzLWVodz09LzMzODc1NTEzNDQ3MTQxNDQ0NDYuanBn.jpg"></a></p>
<p>在上图的结构中，处理器系统首先使用一个虚拟的PCI桥分离处理器系统的存储器域与PCI总线域。FSB总线下的所有外部设备都属于PCI总线域。与这个虚拟PCI桥直接相连的总线为PCI总线0。这种架构与Intel的x86处理器系统较为类似。</p>
<p>在这种结构中，RC由两个FSB-to-PCIe桥和存储器控制器组成。值得注意的是在图4?7中，虚拟PCI桥的作用只是分离存储器域与PCI总线域，但是并不会改变信号的电气特性。RC与处理器通过FSB连接，而从电气特性上看，PCI总线0与FSB兼容，因此在PCI总线0上挂接的是FSB-to-PCIe桥，而不是PCI-to-PCIe桥。</p>
<p>在PCI总线0上有一个存储器控制器和两个FSB-to-PCIe桥。这两个FSB-to-PCIe桥分别推出一个×16和×8的PCIe链路，其中×16的PCIe链路连接显卡控制器(GFX)，其编号为PCI总线1；×8的PCIe链路连接一个Switch进行PCIe链路扩展。而存储器控制器作为PCI总线0的一个Agent设备，连接DDR插槽或者颗粒。</p>
<p>此外在这个PCI总线上还可能连接了一些使用“PCI配置空间”管理的设备，这些设备的访问方法与PCI总线兼容，在x86处理器的Chipset中集成了一些内嵌的设备。这些内嵌的设备使用均使用“PCI配置空间”进行管理，包括存储器控制器。</p>
<p>PCIe总线使用端到端的连接方式，因此只有使用Switch才能对PCIe链路进行扩展，而每扩展一条PCIe链路将产生一个新的PCI总线号。如图4?7所示，Switch可以将1个×8的PCIe端口扩展为4个×2的PCIe端口，其中每一个PCIe端口都可以挂接EP。除此之外PCIe总线还可以使用PCIe桥，将PCIe总线转换为PCI总线或者PCI-X总线，之后挂接PCI/PCI-X设备。多数x86处理器系统使用这种结构连接PCIe或者PCI设备。</p>
<p>在PCIe总线规范中并没有明确提及PCIe主桥，而使用RC概括除了处理器之外的所有与PCIe总线相关的内容。在PCIe体系结构中，RC是一个很模糊也很混乱的概念。Intel使用PCI总线的概念管理所有外部设备，包括与这些外部设备相关的寄存器，因此在RC中包含一些实际上与PCIe总线无关的寄存器。使用这种方式有利于系统软件使用相同的平台管理所有外部设备，也利于平台软件的一致性，但是仍有其不足之处。</p>
<h4>2 PowerPC处理器</h4>
<p>PowerPC处理器挂接外部设备使用的拓扑结构与x86处理器不同。在PowerPC处理器中，虽然也含有PCI/PCIe总线，但是仍然有许多外部设备并不是连接在PCI总线上的。在PowerPC处理器中，PCI/PCIe总线并没有在x86处理器中的地位。在PowerPC处理器中，还含有许多内部设备，如TSEC(Three Speed Ethenet Controller)和一些内部集成的快速设备，与SoC平台总线直接相连，而不与PCI/PCIe总线相连。在PowerPC处理器中，PCI/PCIe总线控制器连接在SoC平台总线的下方。</p>
<p>Freescale即将发布的P4080处理器，采用的互连结构与之前的PowerPC处理器有较大的不同。P4080处理器是Freescale第一颗基于E500 mc内核的处理器。E500 mc内核与之前的E500 V2和V1相比，从指令流水线结构、内存管理和中断处理上说并没有本质的不同。E500mc内核内置了一个128KB大小的L2 Cache，该Cache连接在BSB总线上；而E500 V1/V2内核中并不含有L2 Cache，而仅含有L1 Cache而且与FSB直接相连。在E500mc内核中，还引入了虚拟化的概念。在P4080处理器中，一些快速外部设备，如DDR控制器、以太网控制器和PCI/PCIe总线接口控制器也是直接或者间接地连接到CoreNet中，在P4080处理器，L3 Cache也是连接到CoreNet中。P4080处理器的拓扑结构如图4?8所示。</p>
<p> <a href="http://photo.blog.sina.com.cn/showpic.html#blogid=6472c4cc01018893&amp;url=http://s8.sinaimg.cn/orignal/6472c4ccga6f9acbc8457" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnBoLjEyNi5uZXQvV0ZocjJPQktleG1MTGltSDlMdnpPQT09LzMzODc1NTEzNDQ3MTQxNDQ0NDcuanBn.jpg"></a></p>
<p>目前Freescale并没有公开P4080处理器的L1、L2和L3 Cache如何进行Cache共享一致性。多数采用CoreNet架构互连的处理器系统使用目录表法进行Cache共享一致性，如Intel的Nehelem EX处理器。P4080处理器并不是一个追求峰值运算的SMP处理器系统，而针对Data Plane的应用，因此P4080处理器可能并没有使用基于目录表的Cache一致性协议。在基于全互连网络的处理器系统中如果使用“类总线监听法”进行Cache共享一致性，将不利于多个CPU共享同一个存储器系统，在Cache一致性的处理过程中容易形成瓶颈。</p>
<p>如图4?8所示，P4080处理器的设计重点并不是E500mc内核，而是CoreNet。CoreNet内部由全互连网络组成，其中任意两个端口间的通信并不会影响其他端口间的通信。与MPC8548处理器相同，P4080处理器也使用OceaN<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn1" rel="external nofollow noreferrer">[1]</a>结构连接PCIe与RapidIO接口。</p>
<p>在P4080处理器中不存在RC的概念，而仅存在PCIe总线控制器，当然也可以认为在P4080处理器中，PCIe总线控制器即为RC。P4080处理器内部含有3个PCIe总线控制器，如果该处理器需要连接更多的PCIe设备时，需要使用Switch扩展PCIe链路。</p>
<p>在P4080处理器中，所有外部设备与处理器内核都连接在CoreNet中，而不使用传统的SoC平台总线<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn2" rel="external nofollow noreferrer">[2]</a>进行连接，从而在有效提高了处理器与外部设备间通信带宽的同时，极大降低了访问延时。此外P4080处理器系统使用PAMU(Peripheral Access Management Unit)分隔外设地址空间与CoreNet地址空间。在这种结构下，10GE/1GE接口使用的地址空间与PCI总线空间独立。</p>
<p>P4080处理器使用的PAMU是对MPC8548处理器ATMU的进一步升级。使用这种结构时，外部设备使用的地址空间、PCI总线域地址空间和存储器域地址空间的划分更加明晰。在P4080处理器中，存储器控制器和存储器都属于一个地址空间，即存储器域地址空间。此外这种结构还使用OCeaN连接SRIO<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn3" rel="external nofollow noreferrer">[3]</a>和PCIe总线控制器，使得在OCeaN中的PCIe端口之间<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn4" rel="external nofollow noreferrer">[4]</a>可以直接通信，而不需要通过CoreNet，从而减轻了CoreNet的负载。</p>
<p>从内核互连和外部设备互连的结构上看，这种结构具有较大的优势。但是采用这种结构需要使用占用芯片更多的资源，CoreNet的设计也十分复杂。而最具挑战的问题是，在这种结构之下，Cache共享一致性模型的设计与实现。在Boxboro EX处理器系统中，可以使用QPI将多个处理器系统进行点到点连接，也可以组成一个全互连的处理器系统。这种结构与P4080处理器使用的结构类似，但是Boxboro EX处理器系统包含的CPU更多。</p>
<h4>3 基于PCIe总线的通用处理器结构</h4>
<p>在不同的处理器系统中，RC的实现有较大差异。PCIe总线规范并没有规定RC的实现细则。在有些处理器系统中，RC相当于PCIe主桥，也有的处理器系统也将PCIe主桥称为PCIe总线控制器。而在x86处理器系统中，RC除了包含PCIe总线控制器之外，还包含一些其他组成部件，因此RC并不等同于PCIe总线控制器。</p>
<p>如果一个RC中可以提供多个PCIe端口，这种RC也被称为多端口RC。如MPC8572处理器的RC可以直接提供3条PCIe链路，因此可以直接连接3个EP。如果MPC8572处理器需要连接更多EP时，需要使用Switch进行链路扩展。</p>
<p>而在x86处理器系统中，RC并不是存在于一个芯片中，如在Montevina平台中，RC由MCH和ICH两个芯片组成。本节并不对x86和PowerPC处理器使用的PCIe总线结构做进一步讨论，而只介绍这两种结构的相同之处。一个通用的，基于PCIe总线的处理器系统如图4?9所示。</p>
<p> <a href="http://photo.blog.sina.com.cn/showpic.html#blogid=6472c4cc01018893&amp;url=http://s12.sinaimg.cn/orignal/6472c4ccga6f9afa2ddfb" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnBoLjEyNi5uZXQvUU9qbnB5UE5rdmlOaDFCZVRHUXFIQT09LzMzODc1NTEzNDQ3MTQxNDQ0NDguanBn.jpg"></a></p>
<p>上图所示的结构将PCIe总线端口、存储器控制器等一系列与外部设备有关的接口都集成在一起，并统称为RC。RC具有一个或者多个PCIe端口，可以连接各类PCIe设备。PCIe设备包括EP(如网卡、显卡等设备)、Switch和PCIe桥。PCIe总线采用端到端的连接方式，每一个PCIe端口只能连接一个EP，当然PCIe端口也可以连接Switch进行链路扩展。通过Switch扩展出的PCIe链路可以继续挂接EP或者其他Switch。</p>
<h3>4<a>.2.2 RC</a>的组成结构</h3>
<p>RC是PCIe体系结构的一个重要组成部件，也是一个较为混乱的概念。RC的提出与x86处理器系统密切相关。事实上，只有x86处理器才存在PCIe总线规范定义的“标准RC”，而在多数处理器系统，并不含有在PCIe总线规范中涉及的，与RC相关的全部概念。</p>
<p>不同处理器系统的RC设计并不相同，在图4?7中的处理器系统中，RC包括存储器控制器、两个FSB-to-PCIe桥。而在图4?8中的PowerPC处理器系统中，RC的概念并不明晰。在 PowerPC处理器中并不存在真正意义上的RC，而仅包含PCIe总线控制器。</p>
<p>在x86处理器系统中，RC内部集成了一些PCI设备、RCRB(RC Register Block)和Event Collector等组成部件。其中RCRB由一系列“管理存储器系统”的寄存器组成，而仅存在于x86处理器中；而Event Collector用来处理来自PCIe设备的错误消息报文和PME消息报文。RCRB寄存器组属于PCI总线域地址空间，x86处理器访问RCRB的方法与访问PCI设备的配置寄存器相同。在有些x86处理器系统中，RCRB在PCI总线0的设备0中。</p>
<p>RCRB是x86处理器所独有的，PowerPC处理器也含有一组“管理存储器系统”的寄存器，这组寄存器与RCRB所实现的功能类似。但是在PowerPC处理器中，该组寄存器以CCSRBAR寄存器为基地址，处理器采用存储器映像方式访问这组寄存器。</p>
<p>如果将RC中的RCRB、内置的PCI设备和Event Collector去除，该RC的主要功能与PCI总线中的HOST主桥类似，其主要作用是完成存储器域到PCI总线域的地址转换。但是随着虚拟化技术的引入，尤其是引入MR-IOV技术之后，RC的实现变得异常复杂。</p>
<p>但是RC与HOST主桥并不相同，RC除了完成地址空间的转换之外，还需要完成物理信号的转换。在PowerPC处理器的RC中，来自OCeaN或者FSB的信号协议与PCIe总线信号使用的电气特性并不兼容，使用的总线事务也并不相同，因此必须进行信号协议和总线事务的转换。</p>
<p>在P4080处理器中，RC的下游端口可以挂接Switch扩展更多的PCIe端口，也可以只挂接一个EP。在P4080处理器的RC中，设置了一组Inbound和Outbound寄存器组，用于存储器域与PCI总线域之间地址空间的转换；而P4080处理器的RC还可以使用Outbound寄存器组将PCI设备的配置空间直接映射到存储器域中。PowerPC处理器在处理PCI/PCIe接口时，都使用这组Inbound和Outbound寄存器组。</p>
<p>在P4080处理器中，RC可以使用PEX_CONFIG_ADDR与PEX_CONFIG_DATA寄存器对 EP进行配置读写，这两个寄存器与MPC8548处理器HOST主桥的PCI_CONFIG_ADDR和PCI_CONFIG_DATA寄存器类似，本章不再详细介绍这组寄存器。</p>
<p>而x86处理器的RC设计与PowerPC处理器有较大的不同，实际上和大多数处理器系统都不相同。x86处理器赋予了RC新的含义，PCIe总线规范中涉及的RC也以x86处理器为例进行说明，而且一些在PCIe总线规范中出现的最新功能也在Intel的x86处理器系统中率先实现。在x86处理器系统中的RC实现也比其他处理器系统复杂得多。深入理解x86处理器系统的RC对于理解PCIe体系结构非常重要。</p>
<h3><a>4.2.3 Switch</a></h3>
<p>本篇在第4.1.4节，简单介绍了在PCIe总线中，如何使用Switch进行链路扩展，本节主要介绍Switch<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn5" rel="external nofollow noreferrer">[5]</a>的内部结构。从系统软件的角度上看，每一个PCIe链路都占用一个PCI总线号，但是一条PCIe链路只能连接一个PCI设备，Switch、EP或者PCIe桥片。PCIe总线使用端到端的连接方式，一条PCIe链路只能连接一个设备。</p>
<p>一个PCIe链路需要挂接多个EP时，需要使用Switch进行链路扩展。一个标准Switch具有一个上游端口和多个下游端口。上游端口与RC或者其他Switch的下游端口相连，而下游端口可以与EP、PCIe-to-PCI-X/PCI桥或者下游Switch的上游端口相连。</p>
<p>PCIe总线规范还支持一种特殊的连接方式，即Crosslink连接方式。使用这种方式时，Switch的下游端口可以与其他Switch的下游端口直接连接，上游端口也可以其他Switch的上游端口直接连接。在PCIe总线规范中，Crosslink连接方式是可选的，并不要求PCIe设备一定支持这种连接方式。</p>
<p>在PCIe体系结构中，Switch的设计难度仅次于RC，Switch也是PCIe体系结构的核心所在。而从系统软件的角度上看，Switch内部由多个PCI-to-PCI桥组成，其中每一个上游和下游端口都对应一个虚拟PCI桥。在一个Switch中有多个端口，在其内部就有多少个虚拟PCI桥，就有多少个PCI桥配置空间。值得注意的是，在Switch内部还具有一条虚拟的PCI总线，用于连接各个虚拟PCI桥，系统软件在初始化Switch时，需要为这条虚拟PCI总线编号。Switch的组成结构如图4?10所示。</p>
<p><a href="http://photo.blog.sina.com.cn/showpic.html#blogid=6472c4cc01018893&amp;url=http://s14.sinaimg.cn/orignal/6472c4ccga6f9b28f1fed" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnBoLjEyNi5uZXQvZ2w2dnF0eXE1ZTNEQTBfSXZwSWFmdz09LzMzODc1NTEzNDQ3MTQxNDQ0NDkuanBn.jpg"></a></p>
<p>Switch<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn6" rel="external nofollow noreferrer">[6]</a>需要处理PCIe总线传输过程中的QoS问题。PCIe总线的QoS要求PCIe总线区别对待优先权不同的数据报文，而且无论PCIe总线的某一个链路多么拥塞，优先级高的报文，如等时报文(Isochronous Packet)都可以获得额定的数据带宽。而且PCIe总线需要保证优先级较高的报文优先到达。PCIe总线采用虚拟多通路VC技术<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn7" rel="external nofollow noreferrer">[7]</a>，并在这些数据报文设定一个TC(Traffic Class)标签，该标签由3位组成，将数据报文根据优先权分为8类，这8类数据报文可以根据需要选择不同的VC进行传递。</p>
<p>在PCIe总线中，每一条数据链路上最多可以支持8个独立的VC。每个VC可以设置独立的缓冲，用来接收和发送数据报文。在PCIe体系结构中，TC和VC紧密相连，TC与VC之间的关系是“多对一”。</p>
<p>TC可以由软件设置，系统软件可以选择某类TC由哪个VC进行传递。其中一个VC可以传递TC不相同的数据报文，而TC相同的数据报文在指定一个VC传递之后，不能再使用其他VC。在许多处理器系统中，Switch和RC仅支持一个VC，而x86处理器系统和PLX的Switch中可以支持两个VC。</p>
<p>下文将以一个简单的例子说明如何使用TC标签和多个VC，以保证数据传送的服务质量。我们将PCIe总线的端到端数据传递过程模拟为使用汽车将一批货物从A点运送到B点。如果我们不考虑服务质量，可以采用一辆汽车运送所有这些货物，经过多次往返就可以将所有货物从A点运到B点。但是这样做会耽误一些需要在指定时间内到达B点的货物。有些货物，如一些急救物资、EMS等其他优先级别较高的货物，必须要及时地从A点运送到B点。这些急救物资的运送应该有别于其他普通物资的运送。</p>
<p>为此我们首先将不同种类的货物进行分类，将急救物资定义为TC3类货物，EMS定义为TC2类货物，平信定义为TC1类货物，一般包裹定义为TC0类货物，我们最多可以提供8种TC类标签进行货物分类。</p>
<p>之后我们使用8辆汽车，分别是VC0~7运送这些货物，其中VC7的速度最快，而VC0的速度最慢。当发生堵车事件时，VC7优先行驶，VC0最后行驶。然后我们使用VC3运送急救物资，VC2运送EMS，VC1运送平信，VC0运送包裹，当然使用VC0同时运送平信和包裹也是可以的，但是平信或者包裹不能使用一种以上的汽车运送，如平信如果使用了VC1运输，就不能使用VC0。因为TC与VC的对应关系是“多对一”的关系。</p>
<p>采用这种分类运输的方法，我们可以做到在A点到B点带宽有限的情况下，仍然可以保证急救物资和EMS可以及时到达B点，从而提高了服务质量。</p>
<p>PCIe总线除了解决数据传送的QoS问题之外，还进一步考虑如何在链路传递过程中，使用流量控制机制防止拥塞。</p>
<p>在PCIe体系结构中，Switch处于核心地位。PCIe总线使用Switch进行链路扩展，在Switch中，每一个端口对应一个虚拟PCI桥。深入理解PCI桥是理解Switch软件组成结构的基础。目前PCIe总线提出了MRA-Switch的概念，这种Switch与传统Switch有较大的区别。</p>
<h3>4<a>.2.4 VC</a>和端口仲裁</h3>
<p>在Switch中存在多个端口，其中来自不同Ingress端口的报文可以发向同一个Egress端口，因此Switch必须要解决端口仲裁和路由选径的问题。所谓端口仲裁指来自不同Ingress端口的报文到达同一个Egress端口的报文通过顺序，端口仲裁机制如图4?11所示。</p>
<p><a href="http://photo.blog.sina.com.cn/showpic.html#blogid=6472c4cc01018893&amp;url=http://s14.sinaimg.cn/orignal/6472c4ccga6f9b5a8714d" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnBoLjEyNi5uZXQvV1liRmJLQ2RJejVDb1J2Y0VBaHhZQT09LzMzODc1NTEzNDQ3MTQxNDQ0NTAuanBn.jpg"></a></p>
<p>在一个Switch中设有仲裁器，该仲裁器规定了数据报文通过Switch的规则。在PCIe总线中存在两种仲裁机制，分别是基于VC和基于端口的仲裁机制。端口仲裁机制主要针对RC和Switch，当多个Ingress端口需要向同一个Egress端口发送数据报文时需要进行端口仲裁。具体地讲，在PCIe体系结构中有三个端口，需要进行端口仲裁。</p>
<ul>
<li>Switch的Egress端口。当EP A和EP B同时访问EP C，D或者DDR-SDRAM时，需要通过Switch的Egress端口C。此时Switch需要进行端口仲裁确定是EP A的数据报文还是EP B的数据报文优先通过Egress端口C。</li>
<li>多端口RC的Egress端口。当RC的端口1和端口3同时访问Endpoint C时，RC的端口2需要进行端口仲裁，决定来自RC哪个端口的数据可以率先通过。</li>
<li>RC通往主存储器的端口。当RC的端口1、端口2和端口3同时访问DDR控制器时，这些数据报文将通过RC的Egress端口4，此时需要进行端口仲裁。</li>
</ul>
<p>在PCIe体系结构中，链路的端口仲裁需要根据每一个VC独立设置，而且可以使用不同的算法进行端口仲裁。</p>
<p>下文以图4?11中，Switch的两个Ingress端口A和B向Egress端口C发送数据报文为例，简要说明端口仲裁和VC仲裁的使用方法，其过程如图4?12所示。</p>
<p> </p>
<p>基于VC的仲裁是指发向同一个端口的数据报文，根据使用的VC而进行仲裁的方式。如上图所示，当来自端口B和端口A数据报文(分别使用VC0和VC1通路)在到达端口C之前，需要首先进行端口仲裁后，才能进行VC仲裁。PCIe总线规定了3种VC仲裁方式, 分别为Strict Priority，RR(Round Robin)和WRR(Weighted Round Robin)算法。</p>
<p>当使用Strict Priority仲裁方式时，发向VC7的数据报文具有最高的优先级，而发向VC0的数据报文优先级最低。PCIe总线允许对Switch或者RC的部分VC采用Strict Priority方式进行仲裁，而对其他VC采用RR和WRR算法，如VC7~4采用Strict Priority方式，而采用其他方式处理VC3~0。</p>
<p>使用RR方式时，所有VC具有相同的优先级，所有VC轮流使用PCIe链路。WRR方式与RR算法类似，但是可以对每一个VC进行加权处理，采用这种方式可以适当提高VC7的优先权，而将VC0的优先权适当降低。</p>
<p>我们假定Ingress端口A和Ingress B向Egress端口C进行数据传递时，使用两个VC通路，分别是VC0和VC1。其中标签为TC0～3的数据报文使用VC0传送，而标签为TC4～7数据报文使用VC1传送。</p>
<p>而数据报文在离开Egress端口C时，需要首先进行端口仲裁，之后再通过VC仲裁，决定哪个报文优先传送。数据报文从Ingress A/B端口发送到Egress C端口时，将按照以下步骤进行处理。</p>
<p>(1)      首先到达Ingress A/B端口的数据报文，将根据该端口的TC/VC映射表<a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftn8" rel="external nofollow noreferrer">[8]</a>决定使用该端口的哪个VC通道。如图4?12所示，假设发向端口A的数据报文使用TC0～TC3，而发向端口B的数据报文使用TC0～TC7，这些数据报文在端口A中仅使用了VC0通道，而在端口B中使用了VC0和VC1两个通道。</p>
<p>(2)      数据报文在端口中传递时，将通过路由部件(Routing Logic)，将报文发送到合适的端口。如图4?12所示，端口C可以接收来自端口A或者B的数据报文。</p>
<p>(3)      当数据报文到达端口C时，首先需要经过TC/VC映射表，确定在端口C中使用哪个VC通路接收不同类型的数据报文。</p>
<p>(4)      对于端口C，其VC0通道可能会被来自端口A的数据报文使用，也可能会被来自端口B的数据报文使用。因此在PCIe的Switch中必须设置一个端口仲裁器，决定来自不同数据端口的数据报文如何使用VC通路。</p>
<p>(5)      数据报文通过端口仲裁后，获得VC通路的使用权之后，还需要经过Switch中的VC仲裁器，将数据报文发送到实际的物理链路中。</p>
<p>PCIe总线规定，系统设计者可以使用以下三种方式进行端口仲裁。</p>
<p>(1)      Hardware-fixed仲裁策略。如在系统设计时，采用固化的RR仲裁方法。这种方法的硬件实现原理较为简单，此时系统软件不能对端口仲裁器进行配置。</p>
<p>(2)      WRR仲裁策略，即加权的RR仲裁策略。</p>
<p>(3)      Time-Based WRR仲裁策略，基于时间片的WRR仲裁策略，PCIe总线可以将一个时间段分为若干个时间片(Phase)，每个端口占用其中的一个时间片，并根据端口使用这些时间片的多少对端口进行加权的一种方法。使用WRR和Time-Based WRR仲裁策略，可以在某种程度上提高PCIe总线的QoS。</p>
<p>PCIe设备的Capability寄存器规定了端口仲裁使用的算法。有些PCIe设备并没有提供多种端口仲裁算法，可能也并不含有Capability寄存器。此时该PCIe设备使用Hardware-fixed仲裁策略。</p>
<h3><a>4.2.5 PCIe-to-PCI/PCI-X</a>桥片</h3>
<p>本篇将PCIe-to-PCI/PCI-X桥片简称为PCIe桥片。该桥片有两个作用。</p>
<ul>
<li>将PCIe总线转换为PCI总线，以连接PCI设备。在一个没有提供PCI总线接口的处理器中，需要使用这类桥片连接PCI总线的外设。许多PowerPC处理器在提供PCIe总线的同时，也提供了PCI总线，因此PCIe-to-PCI桥片对基于PowerPC处理器系统并不是必须的。</li>
<li>将PCI总线转换为PCIe总线(这也被称为Reverse Bridge)，连接PCIe设备。一些低端的处理器并没有提供PCIe总线，此时需要使用PCIe桥将PCI总线转换为PCIe总线，才能与其他PCIe设备互连。这种用法初看比较奇怪，但是在实际应用中，确实有使用这一功能的可能。本节主要讲解PCIe桥的第一个作用。</li>
</ul>
<p>PCIe桥的一端与PCIe总线相连，而另一端可以与一条或者多条PCI总线连接。其中可以连接多个PCI总线的PCIe桥也被称为多端口PCIe桥。</p>
<p>PCIe总线规范提供了两种多端口PCIe桥片的扩展方法。多端口PCIe桥片指具有一个上游端口和多个下游端口的桥片。其中上游端口连接PCIe链路，而下游端口推出PCI总线，连接PCI设备。</p>
<p>目前虽然PCIe总线非常普及，但是仍然有许多基于PCI总线的设计，这些基于PCI总线的设计可以通过PCIe桥，方便地接入到PCIe体系结构中。目前有多家半导体厂商可以提供PCIe桥片，如PLX、NXP、Tundra和Intel。就功能的完善和性能而言，Intel的PCIe桥无疑是最佳选择，而PLX和Tundra的PCIe桥在嵌入式系统中得到了广泛的应用。</p>
<hr>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref1" rel="external nofollow noreferrer">[1]</a> OCeaN是一个基于交叉矩阵的总线结构，连接在OCeaN中的外部设备可以直接通信，而不相互干扰。</p>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref2" rel="external nofollow noreferrer">[2]</a> 这种方式也可以被认为是SoC平台总线从共享总线结构升级到Switch结构。</p>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref3" rel="external nofollow noreferrer">[3]</a> SRIO为串型RapidIO。</p>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref4" rel="external nofollow noreferrer">[4]</a> PCIe端口之间的直接通信过程也被称为Peer-to-Peer传送方式。</p>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref5" rel="external nofollow noreferrer">[5]</a> PCIe总线中的Switch与网络应用的Switch的功能并不相同，而与网络应用中的Route功能接近。</p>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref6" rel="external nofollow noreferrer">[6]</a> 在PCIe体系结构中，RC和EP也需要处理QoS。</p>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref7" rel="external nofollow noreferrer">[7]</a> 有关多通路VC的详细说明见第9章。</p>
<p><a href="http://blog.sina.com.cn/s/blog_6472c4cc01018893.html#_ftnref8" rel="external nofollow noreferrer">[8]</a> 该表存在于PCI Express Extended Capabilities结构中。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:46:01</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>4.2 PCIe体系结构的组成部件的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm6PPjz.html" rel="bookmark">4&period;1 PCIe总线的基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				与PCI总线不同,PCIe总线使用端到端的连接方式,在一条PCIe链路的两端只能各连接一个设备,这两个设备互为是数据发送端和数据接收端.PCIe总线除了总线链路外,还具有多个层次,发送端发送数据时将通过这些层次,而接收端接收数据时也使用这些层次.PCIe总线使用的层次结构与网络协议栈较为类似. 4.1.1 端到端的数据传递 PCIe链路使用&quot;端到端的数据传送方式&quot;,发送端和接收端中都含有TX(发送逻辑)和RX(接收逻辑),其结构如图4?1所示. 由上图所示,在PCIe总线的物理链路的一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7EgXz.html" rel="bookmark">3&period;4 预读机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着处理器制造工艺的提高,处理器主频越来越高,存储器和外部设备的访问速度虽然也得到极大的提升,但是依然不与处理器主频的提升速度成正比,从而处理器的运行速度和外部设备的访问速度之间的差距越来越大,存储器瓶颈问题愈发严重.虽然Cache的使用有效缓解了存储器瓶颈问题,但是仅使用Cache远远不够. 因为不管Cache的命中率有多高,总有发生Cache行Miss的情况.一旦Cache行出现Miss,处理器必须启动存储器周期,将需要的数据从存储器重新填入Cache中,这在某种程度上增加了存储器访问的开销			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZAWdb.html" rel="bookmark">第1章 PCI总线的基本知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PCI总线作为处理器系统的局部总线,主要目的是为了连接外部设备,而不是作为处理器的系统总线连接Cache和主存储器.但是PCI总线.系统总线和处理器体系结构之间依然存在着紧密的联系. PCI总线作为系统总线的延伸,其设计考虑了许多与处理器相关的内容,如处理器的Cache共享一致性和数据完整性,以及如何与处理器进行数据交换等一系列内容.其中Cache共享一致性和数据完整性是现代处理器局部总线的设计的重点和难点,也是本书将重点讲述的主题之一. 独立地研究PCI总线并不可取,因为PCI总线仅是处理器系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgaBmz.html" rel="bookmark">小议ebXML</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				xml 作者: ZDNET CHINA 特稿 日期: 2002年02月26日     电子商务,也就是英语e-business一词,是当前技术领域内非常时髦的常用词汇之一,但是,我们真正理解了电子商务吗?电子商务的真正含义是什么呢?从本质上看,所谓电子商务,其实就是采用Internet自动操作和集成常规商务交易的一种方式   .目前,一种名为ebXML的新协议作为常规商务的全球性标准而越来越引起人们的关注,这种新颖的电子商务协议建立在XML和Web服务模式的基础之上. 全新的标准? 初看起来,e			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWkmyp.html" rel="bookmark">结束语</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&quot;浅谈PCIe体系结构&quot;的更新到此告一段落.这些内容主要出自之前书写的&lt;PCI Express体系结构导读&gt;,因为与出版社的协议,无法在此处共享全文,但是也包含了与PCI与PCIe总线相关的最基础的内容.原书正在组织第二次印刷,我却很难有再版的想法.事实上如果我能决定一些事情,不会出现第二次印刷. 书中的错误令不安,却鲜有读者指出.我意识到产生这些现象的原因是更多的入门者在阅读这些内容.与国外的知名教授十年磨一剑去书写书籍,剩下的除了反思还是反思.这些反思使我在今后相当长的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVaQ3b.html" rel="bookmark">《Linux设备驱动开发详解 A》一一2&period;3　接口与总线</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 接口与总线 2.3.1 串口 RS-232.RS-422与RS-485都是串行数据接口标准,最初都是由电子工业协会(EIA)制订并发布的. RS-232在1962年发布,命名为EIA-232-E.之后发布的RS-422定义了一种平衡通信接口,它是一种单机发送.多机接收的单向.平衡传输规范,被命名为TIA/EIA-422-A标准.RS-422改进了RS-232通信距离短.速率低的缺点.为进一步扩展应用范围,EIA又于1983年在RS-422的基础上制定了RS-485标准,增加了多点.双向通			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYdZ75b.html" rel="bookmark">ISC2016在德召开 曙光发布星河（Galaxias）SDC1000服务器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				6月19日至23日,一年一度.巨头云集的国际超级计算大会(ISC2016)在德国法兰克福如期举 行.当地时间6月21日上午,国内领先的高性能计算产品与服务提供商曙光公司联合全球芯片巨头Intel,在ISC2016上正式发布了首款面向云计算的 高密度融合架构服务器产品--星河(Galaxias)SDC1000. 星河SDC1000即具有传统服务器的特点,如采用通用处理器做计算核心.兼容传统服务器的软硬件标准 协议.适配所有商用OS.Hypervisor等生态软件,又独具弹性.异构.按需简约的设计理			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVXGB4M.html" rel="bookmark">智慧计算战略再推进 浪潮新一代服务器M5发布在即</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 7月12日,浪潮将在北京发布新一代服务器M5,浪潮M5新一代服务器全面支持最新英特尔 至强 可扩展处理器(代号为&quot;Skylake&quot;),聚焦云计算.大数据.深度学习(简称CBD)应用场景,强调极致的场景化设计,涵盖关键业务服务器.通用服务器.融合架构服务器和应用优化服务器4大系列.超过35款产品,提供业界最丰富的场景应用产品阵列. 浪潮将于7月12日在京发布新一代服务器M5 面向智慧计算 随着人类社会从信息化到智能化的升级,智慧计算成为计算当中最主要的组成部分.智慧计算以云计算为基础平			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnwPdoz.html" rel="bookmark">小部件、大作用&mdash;&mdash;PCI-E高性能固态存储卡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[天极网网络频道5月31日消息]当前社会信息化高速发展,存储的容量和性能变得越发重要,对于存储阵列中的硬盘来说,其性能水平.稳定性.I/O和组建阵列的灵活扩建方面成为存储重要的选购依据,同时采用多个小容量硬盘堆叠.对硬盘采取池化措施的http://www.aliyun.com/zixun/aggregation/13883.html&quot;&gt;虚拟化技术等措施均被利用于提升存储IOPS.而到了今天我们却发现,真正到了大数据时代,存储实际上已经遇到了瓶颈,而目前弥补这一性能瓶颈的手段无疑就是固态硬盘			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boWvbv.html" rel="bookmark" class="title">113期：电子书《阿里巴巴技术实战2016年刊》重磅发布，免费下载！</a>
					<div>
						本期头条   • [资料合集]首届阿里开源峰会回顾:讲义PDF+活动视频! • [在线峰会]即将直播:大数据技术峰会 • 微博红包技术最佳实践:架构及运维 • 阿里开源数据库AliSQL最佳实践    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK7RLb.html" rel="bookmark" class="title">⑨云上场景：趣拍，短视频一站式解决方案</a>
					<div>
						趣拍SDK的梦想是将视频能力开放,让更多开发者使用这个功能.从诞生日起,在没有任何市场推广的情况下,趣拍SDK的讨论群从无到有,瞬间聚集了数百开发者,吸引数百应用接入,覆盖过亿用户.   早期,趣拍就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjrPNb.html" rel="bookmark" class="title">用XSL&period;ASP编辑XML文档</a>
					<div>
						简介 本文是&quot;保存至HTML 表格数据至XML&quot;的姐妹篇.如果你没读过上文,我建议您最好先浏览一下.本文是建立在上文基础之上的.关于上文的举例,读者不断给予了肯定的回应,同样的,很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL1lLz.html" rel="bookmark" class="title">前锋：列举六种常用的SEO工具</a>
					<div>
						有人问我SEO博客里有SEO工具的分类,怎么没听合肥SEO介绍SEO工具呢?一方面是时间有限,毕竟还要工作,这个SEO博客每天只能更新一点SEO知识,而SEO的内容说多不多说少也不少;另一方面,我们平 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRoe3p.html" rel="bookmark" class="title">也谈SEO搜索引擎优化局限性</a>
					<div>
						从事SEO行业的朋友一定会有人问你们如下两个类似的问题:1.什么时候可以让我的网页在搜索引擎里可以找到?2.什么时候可以在搜索引擎首页用关键词找到我的网站? 由于不同行业.不同类型的网站所执行的优化策 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvVBAM.html" rel="bookmark" class="title">Delphi GDI&plus; 学习记录&lpar;22&rpar;&colon; 输出文本&amp;amp&semi;lt&semi;1&amp;amp&semi;gt&semi;</a>
					<div>
						//输出文本var g: TGPGraphics; sb: TGPSolidBrush; fontFamily: TGPFontFamily; font: TGPFont; begin g := TG ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKvW6p.html" rel="bookmark" class="title">Word 2013怎样使用厘米或英寸度量单位</a>
					<div>
						在Word2013文档中,用户可以使用厘米.英寸.毫米.磅和十二点活字作为度量单位.用户可以根据实际需要进行设置,操作步骤如下所述: 第1步,打开Word2013文档窗口,依次单击&quot;文件&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91D6XM.html" rel="bookmark" class="title">wps表格怎样冻结窗口</a>
					<div>
						wps表格冻结窗口的方法: 1.打开我们的wps表格编辑程序. 2.在我们编辑好的表格中,选择我们要冻结的栏目. 3.之后点击菜单栏的&quot;视图&quot;按钮,在视图栏工具中点击&quot;冻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxa2Ab.html" rel="bookmark" class="title">利用referer防止图片盗链</a>
					<div>
						当浏览器向web服务器发送请求的时候,一般会带上Referer,告诉服务器我是从哪个页面链接过来的,服务器籍此可以获得一些信息用于处理,不过这个Referer是可以伪造,下面看一个示例,大家就明白了  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDANKWb.html" rel="bookmark" class="title">PhotoShop打造逼真的糖艺箭头图标ICON制作教程</a>
					<div>
						俗话说&quot;授人以鱼&quot;不如&quot;授人以渔&quot;. 我最想说的是: 其实只要掌握了物体的素描关系和部分技巧,还原真实的物理表象都是浮云,设计师最主要的不是仅仅怎么在纸上还原真 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8OY3b.html" rel="bookmark" class="title">NVIDIA全新计算卡Tesla P40&sol;P4配置怎么样</a>
					<div>
						  在北京召开的GTC 2016技术大会上,NVIDIA CEO黄仁勋亲自发布了新一代高性能计算卡Tesla P40.Tesla P4,专为人工智能.深度学习.神经网络推演而生. 它们俩将取代上代麦克 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXwvep.html" rel="bookmark" class="title">多重曝光折返镜头 给你一个不一样的荷花季</a>
					<div>
						  从还没学习摄影的时候,眼里就一直充斥着形形色色以荷花为主题的作品,从一开始的惊艳到最后的麻木,说实话,已经没有多少荷花片能让我眼前一亮了.但是,荷花只有一季,到了荷花季,没有哪个摄影人能忍住不去拍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLa46az.html" rel="bookmark" class="title">如何快速设置笔记本电脑一键锁屏</a>
					<div>
						  方法/步骤 1首先得为自己电脑设置一个账户.点击电脑左下角开始菜单,找到&quot;控制面板&quot;选项. 2找到&quot;用户账户&quot;选项.点进进入. 3选择管理账户-&gt;更改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYjROM.html" rel="bookmark" class="title">Mac OS X 基础介绍与使用教程</a>
					<div>
						  Mac OS X v10.5&quot;Leopard&quot;是迄今为止 Apple 发布的技术级别最高的操作系统,但别让这种说法吓到您. 虽然确实内藏乾坤,但 Leopard 无疑使您使用  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBNXDz.html" rel="bookmark" class="title">如何练就一个杀毒U盘</a>
					<div>
						  具体做法如下: 一.下载卡巴斯基 便携版,解压,(注意不要将解压目录置于中文路径中)把文件夹AVP6和Kav6(USB).EXE考到U盘根目录. 二.在U盘根目录下-新建文本文档,写入以下代码:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8Pweb.html" rel="bookmark" class="title">java poi word-这个poi把String写入word文档后，打开文档就报&OpenCurlyDoubleQuote;打开文件错误&rdquo;，求高人解决下</a>
					<div>
						问题描述 这个poi把String写入word文档后,打开文档就报&quot;打开文件错误&quot;,求高人解决下 import java.io.ByteArrayInputStream;impor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eleWb.html" rel="bookmark" class="title">使用asp&period;net Ajax控件PopupControlExtender与GridView联合显示详情列表</a>
					<div>
						众所周知,由社区开发的AjaxControlToolkit,为asp.net展现富客户端效果和提高web程序性能带来了很大的帮助.里面有大量的实现各种功能的控件可供直接使用. PopupControl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6YG6M.html" rel="bookmark" class="title">使用富文本OHAttributedLabel</a>
					<div>
						OHAttributedLabel 富文本标签 https://github.com/AliSoftware/OHAttributedLabel 以下是我渲染出来的效果 OHAttributedLab ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE60PZM.html" rel="bookmark" class="title">CDN---共享单车算啥，阿里云发布共享网络黑科技PCDN，降低视频行业75&percnt;的成本</a>
					<div>
						近日,阿里云发布了名为PCDN的新一代内容分发网络,在全球主流云计算厂商中率先推出基于CDN+P2P技术的内容分发类云产品,引发了整个CDN行业的讨论. 在近年的短视频直播热潮中,CDN无疑是视频基础 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0d1YM.html" rel="bookmark" class="title">从汇编角度分析C语言的过程调用</a>
					<div>
						原文出自[听云技术博客]:http://blog.tingyun.com/web/article/detail/1132 基本术语定义 1.系统栈(system stack)是一个内存区,位于进程地址 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKVeLb.html" rel="bookmark" class="title">淘宝&quest;腾讯&quest;</a>
					<div>
						问题描述 淘宝java开发工程师,杭州腾讯无线业务系统,深圳两个offer帮忙分析下,去哪个好些 问题补充:其他方面是指待遇么?待遇两个差不多,腾讯的好些lerous 写道 解决方案 我个人觉得去腾讯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgZvYb.html" rel="bookmark" class="title">CMD记录器改良版代码&lowbar;DOS&sol;BAT</a>
					<div>
						安装 把代码保存为cmd.bat 放置system32下 把cmd.exe copy为cmd.gif  注册表 添加  HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeB9wb.html" rel="bookmark" class="title">Android系统移植与调试之-------&amp;amp&semi;gt&semi;如何修改Android手机NFC模块，使黑屏时候能够使用NFC</a>
					<div>
						         我们都知道在不修改源代码的情况下,只能是解锁之后才能使用NFC功能.而在锁屏和黑屏2个状态下是没办法用NFC的,但是最近有个客户要求手机在黑屏状态下能够使用NFC,因此我们需要去修改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7Xkwp.html" rel="bookmark" class="title">Java Platform Standard Edition 8 Documentation</a>
					<div>
						Oracle has two products that implement Java Platform Standard Edition (Java SE) 8: Java SE Developme ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrq1GWb.html" rel="bookmark" class="title">使用iSCSI Target创建集中式安全存储（一）</a>
					<div>
						使用iSCSI Target创建集中式安全存储(一) iSCSI 是一种块级别的协议,用于通过TCP/IP网络共享原始存储设备,可以用已经存在的IP和以太网如网卡.交换机.路由器等通过iSCSI协议共 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jLedp.html" rel="bookmark" class="title">JS判断变量是否为空判断是否null&lowbar;javascript技巧</a>
					<div>
						/** * 判断是否null * @param data */ function isNull(data){ return (data == &quot;&quot; || data == undef ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8Q10b.html" rel="bookmark" class="title">工作经验远远比不上学习能力和思考能力，同意么大家？</a>
					<div>
						问题描述 如题,不同意说出理由先 解决方案 解决方案二:你没听说过笨鸟先飞勤能补啥吗解决方案三:这的看是属于那类型的工作了,例如只是一些操作类型等等的工作,就对工作经验操作技巧很高如果要更新很快的类型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEjRAz.html" rel="bookmark" class="title">mybatis两张表相关联，有索引外键怎么进行删除delete</a>
					<div>
						问题描述 mybatis两张表相关联,有索引外键怎么进行删除delete 在写sql语句的时候怎么写比如student和teacher两张表 解决方案 你是想用sql直接写吗?设置外键的时候可以设置它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7v5GM.html" rel="bookmark" class="title">嵌入式平台下的ldd</a>
					<div>
						x86平台有ldd可以很方便的查看对库的依赖关系,但在嵌入式linux环境中没有这个命令,替而代之是 CC=$(CROSS_COMPILE)gcc LDD=$(CROSS_COMPILE)readel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRG0Dz.html" rel="bookmark" class="title">dev中 chartControl 控件 ，鼠标点击事件和鼠标浮动事件</a>
					<div>
						问题描述 dev控件中,chartControl控件显示的柱状图,鼠标移动到柱子上的事件在哪儿? 解决方案 解决方案二:官网,自己查资料去吧.					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
